@echo off
echo.
echo Setting up
echo.
set modulename=DDRMenu
set moduleversion=02.00.01
if exist packages\output\*.zip del packages\output\*.zip
if exist packages\build rd /s /q packages\build

echo.
echo Finding 7-Zip
echo.
set zipexe="%ProgramW6432%\7-zip\7z.exe"
if not exist %zipexe% set zipexe="%ProgramFiles%\7-zip\7z.exe"
if not exist %zipexe% set zipexe="%ProgramFiles(x86)%\7-zip\7z.exe"
if not exist %zipexe% echo Please install 7-Zip!
if not exist %zipexe% goto :EOF

echo.
echo Finding Microsoft Ajax Minifier
echo.
set ajaxminexe="%ProgramW6432%\Microsoft\Microsoft Ajax Minifier\AjaxMin.exe"
if not exist %ajaxminexe% set ajaxminexe="%ProgramFiles%\Microsoft\Microsoft Ajax Minifier\AjaxMin.exe"
if not exist %ajaxminexe% set ajaxminexe="%ProgramFiles(x86)%\Microsoft\Microsoft Ajax Minifier\AjaxMin.exe"
if not exist %ajaxminexe% echo Please install Microsoft Ajax Minifier!
if not exist %ajaxminexe% goto :EOF

echo.
echo Minifying scripts
echo.
pushd ..\DDRMenu_Common
%ajaxminexe% -clobber:true js\jquery.effects.js js\DDRMenu.js Templates\DNNMenu\DNNMenu.js -out Templates\DNNMenu\DNNMenu.min.js
%ajaxminexe% -clobber:true js\jquery.effects.js js\DDRMenu.js Templates\SolPart\SolPartMenu.js -out Templates\SolPart\SolPartMenu.min.js
popd

echo.
echo Packaging
echo.
xcopy VersionSpecific\*.dnn Packages\build\
xcopy ..\DDRMenu_Common\*.htm Packages\build\
xcopy bin\*.DDRMenu.dll Packages\build\bin\
xcopy ..\DDRMenu_NET4.0\bin\*.NET40.dll Packages\build\bin\Providers\

pushd ..\DDRMenu_Common
if exist resources.zip del resources.zip
%zipexe% a -tzip resources.zip @resources.filelist
cd templates
%zipexe% a -tzip ..\resources.zip @resources.filelist
popd

xcopy ..\DDRMenu_Common\resources.zip Packages\build\
pushd Packages\build
%zipexe% a -tzip ..\output\%modulename%_%moduleversion%_DNN5.1.0_NET3.5_Install.zip *
popd

echo.
echo Cleaning up
echo.
rd /s /q Packages\build
del ..\DDRMenu_Common\Templates\DNNMenu\DNNMenu.min.js
del ..\DDRMenu_Common\Templates\SolPart\SolPartMenu.min.js
del ..\DDRMenu_Common\resources.zip
